
public class Anweisungsbaum {	
	/*
	 * Klasse, um die Struktur des Baumes der Gui zu vermitteln.
	 * Ende des Baumes soll ein Top, bzw Bottom Blatt sein, der als aktKlauseln jeweils eine Top, bzw. Bottom Menge hat.
	 */
	String regel;
	String bezeichner;
	int belegung;
	Klauselmenge aktKlauseln; //gekurzte aktuelle Form fuer den Baum
	Klauselmenge aktKlauseln2;//Fuer zweite belegung von Split
	Anweisungsbaum linkeRegel;
	Anweisungsbaum rechteRegel;
	
	public Anweisungsbaum( String reg, String name, int wert,Klauselmenge kls, Klauselmenge kls2, Anweisungsbaum links, Anweisungsbaum rechts){
		aktKlauseln = kls;
		aktKlauseln2 = kls2; //Fuer Zweite Belegung von Split
		regel = reg;
		bezeichner = name;
		belegung = wert;
		linkeRegel = links;
		rechteRegel = rechts;
	}
	
	public Anweisungsbaum(){		
	}
	
	
	public int getNumberLeafs(Anweisungsbaum b){
		/*
		 * Fr GUI wichtig.
		 */
		if (b.rechteRegel != null){
			return getNumberLeafs(b.linkeRegel) + getNumberLeafs(b.rechteRegel);
		}
		if (b.linkeRegel != null){
			return getNumberLeafs(b.linkeRegel);
		}
		return 1;
	}
	
	public Anweisungsbaum getFirstSplitNode(Anweisungsbaum b){
		/*
		 * Fr GUI wichtig.
		 */
		if (b.rechteRegel == null) {
			if (b.linkeRegel == null){
				return null;				
			}else{
				return getFirstSplitNode(b.linkeRegel);
			}
		}else{
			return b;
		}
	}
	
	public int getNumberSplit(){
		/*
		 * Gibt Anzahl Verzweigungen aus. Wird fuer Berechnung der breite des Canvas benoetigt.
		 */
		int res = 0;
		if (rechteRegel == null){
			if(linkeRegel != null){
				res += linkeRegel.getNumberSplit();
			}else{
				return 0;
			}
			
			}else {
				res += 1 + linkeRegel.getNumberSplit() +rechteRegel.getNumberSplit();
			}
		
		return res;		
	}
	
	public int getDepth(){
		/*
		 * Gibt Tiefe des Baums aus. Wird fuer Berechnung der hoehe des Canvas benoetigt.
		 */
		int res = 0;
		if (rechteRegel == null){
			if(linkeRegel != null){
				res += 1+ linkeRegel.getDepth();
			}else{
				return 0;
			}
			
			}else {
				res += 1 + Math.max(linkeRegel.getDepth(),rechteRegel.getDepth());
			}
		
		return res;	
	}
	
	public void setRegel(String reg){
		regel = reg;
	}
	
	public void setBezeichner(String bez){
		bezeichner = bez;
	}
	
	public void setBelegung(int bel){
		belegung = bel;
	}
	
	public void setKlauselmenge(Klauselmenge kl){
		aktKlauseln = kl;
	}
	
	public void setLinkeRegel(Anweisungsbaum b){
		linkeRegel = b;
	}
	
	public void setRechteRegel(Anweisungsbaum b){
		rechteRegel = b;
	}

}
